/* brainsik fractal generator */
/* hacked beyond recoginition by brian */
/*
 * TODO:
 *
 * better error handling of incorrect palletes
 *
 *
 * 
 */
#include <gtk/gtk.h>
#include <assert.h>
#ifdef USE_THREADS
#include <pthread.h>
#include <semaphore.h>
#endif
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <libquat.h>
#include "pvwin.h"

extern "C" {
  int eq_table_iter(eq_table*, double *);
}

preview_window * fucking_global;
 
void key_press_callback(GtkWidget * widget, GdkEvent * e, gpointer g) {
    
    fucking_global->handle_key(&e->key);
}

void button_press_callback(GtkWidget * widget, GdkEvent * e, gpointer g) {
    
    fucking_global->handle_mouse_down(&e->button);
}

void button_release_callback(GtkWidget * widget, GdkEvent * e, gpointer g) { }

void motion_notify_callback(GtkWidget * widget, GdkEvent * e, gpointer g) {
    
    fucking_global->handle_move(&e->motion);
}

extern struct yy_buffer_state * yy_scan_string(const char *);
extern int yyparse();
extern int yydebug;

#include "pbfe.h"

void load_pallete(Parameters *);
void compute_line(Parameters *, PIXEL *, int, int);
void * start_threads(void * _parms);
void * test_divergence(void * _parms);
gint display_fractal(gpointer d);

int main(int argc, char *argv[])
{
  Parameters * parms = new Parameters;
  int i, fractype = 0;
  int btest = 0;

  yydebug = 0;
  
  parms->num_threads = 1;
  parms->bailout = 0;
  parms->height = parms->width = 0; /* defaults */
  strcpy(parms->filename, "output.gif");
  parms->crosshair.s = parms->crosshair.a = 0;
  parms->hspan = parms->vspan = 3.0;
  parms->maxiter = 500;
  parms->limit = 256;
  parms->maxpow = 2;
  parms->image_bytes = 1;
  parms->image_channels = 1;
  parms->smooth = 0;
  parms->color_by_angle = 0;
  parms->compile = false;

  gtk_init(&argc, &argv);
  
  char * func = NULL;
  char * init_func = NULL;

  for (i = 1; i < argc; ++i)
      if(strcmp(argv[i], "-ib") == 0)
	  parms->image_bytes = atoi(argv[++i]);
  
      else if(strcmp(argv[i], "-s") == 0)
	  parms->smooth = 1;

      else if(strcmp(argv[i], "-cba") == 0)
	  parms->color_by_angle = 1;
  
      else if(strcmp(argv[i], "-ic") == 0)
	  parms->image_channels = atoi(argv[++i]);
      
      else if(strcmp(argv[i], "-nt") == 0)
	  parms->num_threads = atoi(argv[++i]);

      else if (strcmp(argv[i], "-pf") == 0) 
	  parms->pallete_file = argv[++i];

      else if(strcmp(argv[i], "-c") == 0)
	  parms->compile = true;
  
      else if (strcmp(argv[i], "-size") == 0) {
	  parms->width = atoi(argv[++i]);
	  parms->height = atoi(argv[++i]);
      }

      else if (strcmp(argv[i], "-b") == 0) {
	  sscanf(argv[++i], " %lf ", &parms->bailout);
	  printf("%s\n", argv[i]);
      }
      else if (strcmp(argv[i], "-center") == 0) {
	  parms->crosshair.s = atof(argv[++i]);
	  parms->crosshair.a = atof(argv[++i]);
	  parms->crosshair.b = atof(argv[++i]);
	  parms->crosshair.c = atof(argv[++i]);
      }

      else if (strcmp(argv[i], "-span") == 0) {
	  parms->hspan = atof(argv[++i]);
	  parms->vspan = atof(argv[++i]);
      }

      else if (strcmp(argv[i], "-hv") == 0) {
	  parms->hstep.s = atof(argv[++i]);
	  parms->hstep.a = atof(argv[++i]);
	  parms->hstep.b = atof(argv[++i]);
	  parms->hstep.c = atof(argv[++i]);
      }

      else if(strcmp(argv[i], "-vv") == 0) {
	  parms->vstep.s = atof(argv[++i]);
	  parms->vstep.a = atof(argv[++i]);
	  parms->vstep.b = atof(argv[++i]);
	  parms->vstep.c = atof(argv[++i]); 
      }

      else if (strcmp(argv[i], "-f") == 0)
	  strcpy(parms->filename, argv[++i]);

      else if(strcmp(argv[i], "-i") == 0)
	  parms->maxiter = atoi(argv[++i]);

      else if(strcmp(argv[i], "-gt") == 0)
	  btest = 1;

      else if(strcmp(argv[i], "-l") == 0)
	  parms->limit = (int)atof(argv[++i]);

      else if(strcmp(argv[i], "-F") == 0)
	  func = argv[++i];

      else if(strcmp(argv[i], "-IF") == 0)
	  init_func = argv[++i];

      else if(strcmp(argv[i], "-p") == 0)
	  parms->maxpow = atoi(argv[++i]);
  
  if (!parms->height || !parms->width) {
      parms->height = parms->width = 200;
      printf("Image size defaulting to %dx%d.\n", parms->width, parms->height);
  } if (!parms->bailout) {
      parms->bailout = 100;
      printf("Bailout value defaulting to %d.\n", parms->bailout);
  } if (!func) {
      printf("need func...\n");
  }

  parms->image_bits = parms->image_bytes*8;
//  parms->image_channels = 1;

  load_pallete(parms);

/*   printf("vstep is %.2f %.2f %.2f %.2f\n", parms->vstep.s,  */
/* 	 parms->vstep.a, parms->vstep.b, parms->vstep.c); */
/*   printf("hstep is %.2f %.2f %.2f %.2f\n", parms->hstep.s,  */
/* 	 parms->hstep.a, parms->hstep.b, parms->hstep.c); */


  double sum = sqrt(parms->vstep.s*parms->vstep.s+
		    parms->vstep.a*parms->vstep.a+
		    parms->vstep.b*parms->vstep.b+
		    parms->vstep.c*parms->vstep.c);

  parms->vstep.s /= sum;
  parms->vstep.a /= sum;
  parms->vstep.b /= sum;
  parms->vstep.c /= sum;

  parms->vstep.s *= parms->vspan/parms->height;
  parms->vstep.a *= parms->vspan/parms->height;
  parms->vstep.b *= parms->vspan/parms->height;
  parms->vstep.c *= parms->vspan/parms->height;

/*   printf("vstep is %.10f %.10f %.10f %.10f\n", parms->vstep.s,  */
/* 	 parms->vstep.a, parms->vstep.b, parms->vstep.c); */

  sum = sqrt(parms->hstep.s*parms->hstep.s+
	     parms->hstep.a*parms->hstep.a+
	     parms->hstep.b*parms->hstep.b+
	     parms->hstep.c*parms->hstep.c);

  parms->hstep.s /= sum;
  parms->hstep.a /= sum;
  parms->hstep.b /= sum;
  parms->hstep.c /= sum;

  parms->hstep.s *= parms->hspan/parms->width;
  parms->hstep.a *= parms->hspan/parms->width;
  parms->hstep.b *= parms->hspan/parms->width;
  parms->hstep.c *= parms->hspan/parms->width;

/*   printf("hstep is %.10f %.10f %.10f %.10f\n", parms->hstep.s,  */
/* 	 parms->hstep.a, parms->hstep.b, parms->hstep.c); */

  parms->min.s = parms->crosshair.s-(parms->height/2*parms->vstep.s+
				     parms->width/2*parms->hstep.s);
  parms->min.a = parms->crosshair.a-(parms->height/2*parms->vstep.a+
				     parms->width/2*parms->hstep.a);
  parms->min.b = parms->crosshair.b-(parms->height/2*parms->vstep.b+
				     parms->width/2*parms->hstep.b);
  parms->min.c = parms->crosshair.c-(parms->height/2*parms->vstep.c+
				     parms->width/2*parms->hstep.c);

/*   printf("min is %.2f %.2f %.2f %.2f\n", parms->min.s,  */
/* 	 parms->min.a, parms->min.b, parms->min.c); */
/*   printf("vstep is %.2f %.2f %.2f %.2f\n", parms->vstep.s,  */
/* 	 parms->vstep.a, parms->vstep.b, parms->vstep.c); */
/*   printf("hstep is %.2f %.2f %.2f %.2f\n", parms->hstep.s,  */
/* 	 parms->hstep.a, parms->hstep.b, parms->hstep.c); */

  parms->table = new eq_table(func, init_func,
			      parms->maxiter,
			      parms->bailout);
  if(btest)
      parms->table->set_btest(LIBQUAT_GT);

//  parms->table[0]->set_debug();
  if(parms->compile)
      parms->f = parms->table->compile();
  else
      parms->f = &eq_table_iter;

  parms->f1 = parms->table->compile_1();

  if(parms->f1 == NULL || parms->f == NULL) {
    fprintf(stderr, "couldn't compile func");
    exit(-1);
  }

  parms->pwin = new preview_window(parms, parms->image_channels == 3 ? 
				   GTK_PREVIEW_COLOR : GTK_PREVIEW_GRAYSCALE);
  
  gtk_signal_connect(GTK_OBJECT(parms->pwin->win), "button_press_event",
		     GTK_SIGNAL_FUNC(button_press_callback),
		     (gpointer)parms->pwin->prev);

  gtk_signal_connect(GTK_OBJECT(parms->pwin->win), "button_release_event",
		     GTK_SIGNAL_FUNC(button_release_callback),
		     (gpointer)parms->pwin->prev);

  gtk_signal_connect(GTK_OBJECT(parms->pwin->win), "motion_notify_event",
		     GTK_SIGNAL_FUNC(motion_notify_callback),
		     (gpointer)parms->pwin->prev);

  gtk_signal_connect(GTK_OBJECT(parms->pwin->win), "key_press_event",
		     GTK_SIGNAL_FUNC(key_press_callback), 
		     (gpointer)parms->pwin->prev);

  fucking_global = parms->pwin;

  gtk_widget_set_events(GTK_WIDGET(parms->pwin->win),
			GDK_BUTTON_PRESS_MASK | 
			GDK_KEY_PRESS_MASK |
			GDK_POINTER_MOTION_MASK |
			GDK_BUTTON_RELEASE_MASK);

  gtk_widget_set_events(GTK_WIDGET(parms->pwin->prev),
			GDK_BUTTON_PRESS_MASK | 
			GDK_KEY_PRESS_MASK |
			GDK_POINTER_MOTION_MASK |
			GDK_BUTTON_RELEASE_MASK);
  
  int nshades = parms->image_bytes == 1 ? 0xFF : 0xFFFF;

				/* maybe problems here with greyscale */
  gtk_preview_set_color_cube(nshades, nshades, nshades, nshades);
  gtk_widget_show(GTK_WIDGET(parms->pwin->win));

#ifdef USE_THREADS
  parms->currthread = 0;
  
  parms->q = new Queue<PIXEL>(100);

  sem_init(&parms->diverg_mutex, 0, 1);

  pthread_t writer;
  pthread_attr_t attrs;		/* create threads */
  pthread_attr_init(&attrs);
  pthread_attr_setdetachstate(&attrs, PTHREAD_CREATE_DETACHED);
  
  pthread_create(&writer, &attrs, start_threads, (void *)parms);
#endif
//   printf("check2\n"); 

  parms->image = new PIXEL*[parms->height];
  
  gtk_timeout_add(1, display_fractal, (gpointer)parms);

/*   printf("check3\n"); */

  gtk_main();

  printf("\nCrosshair: (%f,%f)   Resolution: %f x %f\n", 
	 parms->crosshair.s, parms->crosshair.a, parms->hspan, parms->vspan);
  printf("Output file to %s.\n", parms->filename);
  return 0;
}

gint display_fractal(gpointer d) {

  PIXEL * line;
  int count = 0;
  Parameters * parms = (Parameters *)d;
  GdkRectangle bound;
  bound.height = 1;
  bound.width = parms->width;
  bound.x = 0;

#ifdef USE_THREADS
  
  while(1) {
      line = parms->q->remove();
      if(!line) 
	  break;
      parms->image[count] = line;
      gtk_preview_draw_row(GTK_PREVIEW(parms->pwin->prev), 
			   line, 0, count, parms->width);
//      parms->pwin->prev->draw_row(line, 0, count, parms->width);
      bound.y = count;
//      parms->pwin->draw(&bound);
      gtk_widget_draw(GTK_WIDGET(parms->pwin->win), &bound);
      count++;
  }
#else

  for(int i = 0 ; i < parms->height ; i++) {
      parms->image[i] = new PIXEL[parms->width*parms->image_bytes*parms->image_channels];
      compute_line(parms, parms->image[i], i, 0);
      gtk_preview_draw_row(GTK_PREVIEW(parms->pwin->prev), 
			   parms->image[i], 0, i, parms->width);
      bound.y = i;
      gtk_widget_draw(GTK_WIDGET(parms->pwin->win), &bound);
  }
#endif

  parms->pwin->grab_image();

  return(0);			/* return 0 so function is not called again */
}

#ifdef USE_THREADS
int get_next_divergence_block(Parameters * parms) {

  int retval;
    
  sem_wait(&parms->diverg_mutex);
  if(parms->currblock != parms->height)
    retval = parms->currblock++;
  else
    retval = -1;
  sem_post(&parms->diverg_mutex);

  return retval;
}

int get_thread_num(Parameters * parms) {

    int retval;
    sem_wait(&parms->diverg_mutex);
    retval = parms->currthread++;
    sem_post(&parms->diverg_mutex);
    return(retval);
}

void * test_divergence(void * _parms) {

  Parameters * parms = (Parameters*)_parms;
  PIXEL *line;
  int block;

  int thread_num = get_thread_num(parms);

  while((block = get_next_divergence_block(parms))!=-1) {
      line = new PIXEL[parms->width*parms->image_bytes*parms->image_channels];
      compute_line(parms, line, block, thread_num);
      parms->q->insert(line, block);
  }
  pthread_exit(0);
}

void * start_threads(void * _parms) {

  Parameters * parms = (Parameters*)_parms;
  int i;

/*   printf("start_threads\n"); */

  pthread_t thread[parms->num_threads];
  for(i = 0 ; i < parms->num_threads ; i++)
    pthread_create(&thread[i], NULL, test_divergence, (void *)parms);

  for(i = 0 ; i < parms->num_threads ; i++)
    pthread_join(thread[i], NULL);

/*   printf("joined\n"); */

  parms->q->insert(NULL, parms->height);

/*   parms->q->dump_state(); */
  
  pthread_exit(0);
}
#endif // USE_THREADS
void compute_line(Parameters * parms, PIXEL * line, int which_line, int which_table) {
  quat pt, line_start;
  double r;
  double a, b;
  int i, pixel_x, iter;
  double log_of_maxpow = log(parms->maxpow);

//  printf("init compute\n");

  line_start.s = parms->min.s+which_line*parms->vstep.s;
  line_start.a = parms->min.a+which_line*parms->vstep.a;
  line_start.b = parms->min.b+which_line*parms->vstep.b;
  line_start.c = parms->min.c+which_line*parms->vstep.c;
  
  for (pixel_x = 0; pixel_x < parms->width; ++pixel_x) {
    iter = 0;
				// maybe do this incrementally
    pt.s = line_start.s + pixel_x * parms->hstep.s; 
    pt.a = line_start.a + pixel_x * parms->hstep.a;
    pt.b = line_start.b + pixel_x * parms->hstep.b;
    pt.c = line_start.c + pixel_x * parms->hstep.c;

				// iterate point
    double v[4];
    v[0] = pt.s;
    v[1] = pt.a;
    v[2] = pt.b;
    v[3] = pt.c;

    iter = (*parms->f)(parms->table, v);

    r = v[0]*v[0]+v[1]*v[1]+v[2]*v[2]+v[3]*v[3];
    
    if(!finite(r)) {

	r = parms->bailout;
	fprintf(stderr, "got NaN or INF at point %.5f %.5f\n", pt.s, pt.a);
/* 	exit(-1); */
    }

    int wrapped = 0;

    if(iter < parms->maxiter || parms->color_by_angle) { /* hack!!! */
	if(parms->smooth) {
	    double fuck = sqrt(r);
/* 	    if(fuck < 1.0) */
/* 		b = iter; */
/* 	    else */
	    b = iter - log(log(sqrt(r)))/log_of_maxpow;
	    if(!finite(b))
		b = iter;
	    a = fabs(fmod(b,parms->limit));
	    
//    	if (a<0) {
// 	    a+=parms->limit;
// 	    wrapped = 1;
// 	}
	} else if(parms->color_by_angle) {
	    a = atan2(v[0], v[1])/(2*3.1415926535897)+0.5;
	    b = iter;
	} else {
	    a = b = iter;
	}

#ifdef COLOR
	a /= parms->limit;	// normalize to (0,1)
				// determine which gradient to use
	int which_gradient = (int)fmod(b/parms->limit, parms->pallete_size);

	char from_color[parms->image_channels*parms->image_bytes];
	char to_color[parms->image_channels*parms->image_bytes];
	char this_color[parms->image_channels*parms->image_bytes];

				// get endpoint colors
	memcpy(from_color, parms->pallete+which_gradient*
	       parms->image_channels*parms->image_bytes,
	       parms->image_channels*parms->image_bytes);

	memcpy(to_color,parms->pallete+((which_gradient+1)%parms->pallete_size)*
	       parms->image_channels*parms->image_bytes,
	       parms->image_channels*parms->image_bytes);

	if(parms->image_channels == 1) {
	    if(parms->image_bytes == 2) {
		WYDE_R(this_color) = (short unsigned int)(a*(WYDE_R(to_color) - WYDE_R(from_color)) + WYDE_R(from_color));

// 		printf("color = %x\n", WYDE_R(this_color));
		WYDE_R(line+2*pixel_x) = WYDE_R(this_color);
	    } else {
	      BYTE_R(this_color) = (unsigned char)(a*(BYTE_R(to_color) - BYTE_R(from_color)) + BYTE_R(from_color));
		
		BYTE_R(line+pixel_x) = BYTE_R(this_color);
	    }
	} else {
	    if(parms->image_bytes == 2) {
		WYDE_R(this_color) = (short unsigned int)(a*(WYDE_R(to_color) - WYDE_R(from_color)) + WYDE_R(from_color));
		WYDE_G(this_color) = (short unsigned int)(a*(WYDE_G(to_color) - WYDE_G(from_color)) + WYDE_G(from_color));
		WYDE_B(this_color) = (short unsigned int)(a*(WYDE_B(to_color) - WYDE_B(from_color)) + WYDE_B(from_color));
		
		WYDE_R(line+pixel_x*6) = WYDE_R(this_color);
		WYDE_G(line+pixel_x*6) = WYDE_G(this_color);
		WYDE_B(line+pixel_x*6) = WYDE_B(this_color);
	    } else {
		BYTE_R(this_color) = (unsigned int)(a*(BYTE_R(to_color) - BYTE_R(from_color)) + BYTE_R(from_color));
		BYTE_G(this_color) = (unsigned int)(a*(BYTE_G(to_color) - BYTE_G(from_color)) + BYTE_G(from_color));
		BYTE_B(this_color) = (unsigned int)(a*(BYTE_B(to_color) - BYTE_B(from_color)) + BYTE_B(from_color));
		
		BYTE_R(line+pixel_x*3) = BYTE_R(this_color);
		BYTE_G(line+pixel_x*3) = BYTE_G(this_color);
		BYTE_B(line+pixel_x*3) = BYTE_B(this_color);
	    }
	}

#endif
    } else {
#ifdef COLOR
	if(parms->image_channels == 1) 
	    if(parms->image_bytes == 1) 
		BYTE_R(line+pixel_x) = 0x00;
	    else 
		WYDE_R(line+2*pixel_x) = 0x0000;
	else {
	    if(parms->image_bytes == 1) {
		BYTE_R(line+pixel_x*3) = 0x00;
		BYTE_G(line+pixel_x*3) = 0x00;
		BYTE_B(line+pixel_x*3) = 0x00;
	    } else {
		WYDE_R(line+pixel_x*6) = 0x0000;
		WYDE_G(line+pixel_x*6) = 0x0000;
		WYDE_B(line+pixel_x*6) = 0x0000;
	    }
	}

#else
	line[parms->image_bytes*pixel_x] = (PIXEL)0x0000;
#endif

    }    
  }

//  printf("exit_compute\n");
}

void load_pallete(Parameters * parms) {
    
    double buf[1024];		// probably big enough..
    int i = 0;
    int maxval = (1<<parms->image_bits)-1; // this is white ?

    FILE * fp = fopen(parms->pallete_file, "r");

    if(!fp) {
	printf("could not open pallete file %s\n", parms->pallete_file);
	exit(-1);
    }
    
    if(parms->image_channels == 3) {
	while(fscanf(fp, " { %lf %lf %lf } ", &buf[i], &buf[i+1], &buf[i+2])==3)
	    i+=3;
	i/=3;
    } else while(fscanf(fp, " { %lf } ", &buf[i])==1) i++;

    parms->pallete_size = i;

    if(i<2) {
	printf("pallete of size 1 will yield solid image\n");
	printf("might I suggest using bucket fill in the gimp instead?\n");
	exit(-1);
    }

    parms->pallete = new BYTE[i*parms->image_bytes*parms->image_channels];

//     printf("max is %x\n", (1<<(parms->image_bits))-1);

    for(int j = 0 ; j < i ; j++) 
	if(parms->image_channels == 1)
	    if(parms->image_bytes == 1)
		BYTE_R(parms->pallete+j) = (BYTE)(buf[j]*maxval);
	    else
		WYDE_R(parms->pallete+j*2) = (WYDE)(buf[j]*maxval);
	else
	    if(parms->image_bytes == 1) {
		BYTE_R(parms->pallete+j*3) = (BYTE)(buf[j*3]*maxval);
		BYTE_G(parms->pallete+j*3) = (BYTE)(buf[j*3+1]*maxval);
		BYTE_B(parms->pallete+j*3) = (BYTE)(buf[j*3+2]*maxval);
	    } else {
		WYDE_R(parms->pallete+j*6) = (WYDE)(buf[j*3]*maxval);
		WYDE_G(parms->pallete+j*6) = (WYDE)(buf[j*3+1]*maxval);
		WYDE_B(parms->pallete+j*6) = (WYDE)(buf[j*3+2]*maxval);
	    }
}

#ifdef USE_PNG

void init_png(Parameters * parms) {

  parms->png_file = fopen(parms->filename, "wb");
  
  if(!parms->png_file) {
      fprintf(stderr, "couldn't open file %s\n", parms->filename);
      exit(-1);
  }

  parms->png_ptr = png_create_write_struct(PNG_LIBPNG_VER_STRING, 
					   NULL, NULL, NULL);
  parms->info_ptr = png_create_info_struct(parms->png_ptr);
 
  if(!parms->info_ptr) {
    fprintf(stderr, "failed to create png struct\n");
    exit(-1);
  }

  if(setjmp(parms->png_ptr->jmpbuf)) {
    fprintf(stderr, "error.  exiting\n");
    exit(-1);
  }

  png_init_io(parms->png_ptr, parms->png_file);
  png_set_IHDR(parms->png_ptr, parms->info_ptr, parms->width, parms->height,
	       parms->image_bits, 
	       (parms->image_channels == 3) ? PNG_COLOR_TYPE_RGB : 
	       PNG_COLOR_TYPE_GRAY,
	       PNG_INTERLACE_NONE,
	       PNG_COMPRESSION_TYPE_DEFAULT,
	       PNG_FILTER_TYPE_DEFAULT);
  png_write_info(parms->png_ptr, parms->info_ptr);
  png_set_swap(parms->png_ptr);	/* only on little endian ;< */
}

#endif
