#!/usr/bin/perl

use lib '/home/brian/src/bfe';
use Gimp qw( :auto); 
use Bfe::Graphics;
use Bfe::Zoom;
use Bfe::Span;
use Bfe::Html;
use strict;

package Bfe;

Gimp::set_trace(Gimp::TRACE_CALL);

$| = 1;

sub net {
  my $pwd = `pwd`;
  chop $pwd;
    
  my $file = @ARGV[0] or die "give me a file damnit!!!\n";
  
  my $parms;
  eval('$parms = '.`cat $file`.';'); # grab config
  die "couldn't parse $file: $@" if $@;
  
  &Bfe::Graphics::make_text($parms->{text}) if($parms->{text});
  &Bfe::Graphics::make_bar($parms->{bar}) if($parms->{bar});
  &Bfe::Zoom::generate($parms->{zoom}) if($parms->{zoom});  
  &Bfe::Span::generate($parms->{span}) if($parms->{span});
  &Bfe::Html::parse_html($parms->{html}) if($parms->{html});
}

exit Gimp::gimp_main;			 # necessary for some reason..




