#ifndef SPLAT_H
#define SPLAT_H

class Splat {

public:

    Splat(double _sigma, double thresh, int _size);
    double area_under(double x, double y);

private:

    double func_at(double, double);
    float ** values;
    double sigma;
    double span;
    int size;
    double sigma_sq;
    double delta;
    double delta_sq;
    double coef1, coef2;
    double c1;
    int c2;

};

#endif
